from sdk32 import *
import os, stat

wnd_list = wnd_text = old_wnd_proc = valid_file = 0
rect = RECT()
ps = PAINTSTRUCT()
tm = TEXTMETRIC()
buff = Buffer()
file_name = ''

stardotstar = '*.*'

def list_proc(wnd, msg, wparam, lparam):
    if msg == WM_KEYDOWN and wparam == VK_RETURN:
        SendMessage(GetParent(wnd), WM_COMMAND, MAKELONG(1, LBN_DBLCLK), 0)
    return CallWindowProc(old_wnd_proc, wnd, msg, wparam, lparam)
    
def wnd_proc(wnd, msg, wparam, lparam):
    global wnd_list, wnd_text, old_wnd_proc, valid_file, file_name
    if msg == WM_CREATE:
        dc = GetDC(wnd)
        SelectObject(dc, GetStockObject(SYSTEM_FIXED_FONT))
        GetTextMetrics(dc, tm)
        ReleaseDC(wnd, dc)

        rect.left = 20 * tm.ave_char_width
        rect.top = 3 * tm.height

        wnd_list = CreateWindow('listbox', None,
                                WS_CHILDWINDOW | WS_VISIBLE | LBS_STANDARD,
                                tm.ave_char_width, tm.height * 3,
                                tm.ave_char_width * 13 + GetSystemMetrics(SM_CXVSCROLL),
                                tm.height * 10, wnd, 1,
                                GetWindowLong(wnd, GWL_HINSTANCE), None)
        wnd_text = CreateWindow('static', os.getcwd(),
                                WS_CHILDWINDOW | WS_VISIBLE | SS_LEFT,
                                tm.ave_char_width, tm.height,
                                tm.ave_char_width * 1024, tm.height,
                                wnd, 2,
                                GetWindowLong(wnd, GWL_HINSTANCE), None)
        old_wnd_proc = SetWindowLong(wnd_list, GWL_WNDPROC, list_proc)
        SendMessage(wnd_list, LB_DIR, 0x37, string_to_ptr(stardotstar))
        return 0

    elif msg == WM_SIZE:
        rect.right = LOWORD(lparam)
        rect.bottom = HIWORD(lparam)
        return 0

    elif msg == WM_SETFOCUS:
        SetFocus(wnd_list)
        return 0

    elif msg == WM_COMMAND:
        if LOWORD(wparam) == 1 and HIWORD(wparam) == LBN_DBLCLK:
            i = SendMessage(wnd_list, LB_GETCURSEL, 0, 0)
            if i == LB_ERR:
                return DefWindowProc(wnd, msg, wparam, lparam)
            l = SendMessage(wnd_list, LB_GETTEXTLEN, i, 0)
            buffer_ensure_size(buff, l + 1)
            ptr = buffer_get_ptr(buff)
            n = SendMessage(wnd_list, LB_GETTEXT, i, ptr)
            name = string_from_ptr(ptr)

            if name[0] == '[' and name[-1] == ']':
                name = name[1:-1]
            st = os.stat(name)
            if stat.S_ISDIR(st.st_mode):
                valid_file = 0
                os.chdir(name)
                SetWindowText(wnd_text, os.getcwd())
                SendMessage(wnd_list, LB_RESETCONTENT, 0, 0)
                SendMessage(wnd_list, LB_DIR, 0x37, string_to_ptr(stardotstar))
            else:
                valid_file = 1
                file_name = os.path.join(os.getcwd(), name)
                SetWindowText(wnd_text, file_name)
            InvalidateRect(wnd, None, TRUE)
        return 0

    elif msg == WM_PAINT:
        dc = BeginPaint(wnd, ps)
        SelectObject(dc, GetStockObject(SYSTEM_FIXED_FONT))
        SetTextColor(dc, GetSysColor(COLOR_WINDOWTEXT))
        SetBkColor(dc, GetSysColor(COLOR_WINDOW))
        if valid_file:
            try:
                fp = open(file_name)
                text = fp.read(2048)
                fp.close()
                DrawText(dc, text, len(text), rect,
                         DT_WORDBREAK | DT_EXPANDTABS | DT_NOCLIP | DT_NOPREFIX)
            except IOError:
                valid_file = 0
        EndPaint(wnd, ps)
        return 0

    elif msg == WM_DESTROY:
        PostQuitMessage(0)
        return 0

    return DefWindowProc(wnd, msg, wparam, lparam)

def winmain(inst, prev_inst, cmd_line, cmd_show):
    app_name = 'Head'

    wc = WNDCLASSEX()
    wc.style = CS_HREDRAW | CS_VREDRAW
    wc.wnd_proc = wnd_proc
    wc.inst = inst
    wc.cursor = LoadCursor(0, IDC_ARROW)
    wc.background = COLOR_WINDOW + 1
    wc.name = app_name
    RegisterClassEx(wc)

    wnd = CreateWindow(app_name, 'File Head',
                       WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN,
                       CW_USEDEFAULT, CW_USEDEFAULT,
                       CW_USEDEFAULT, CW_USEDEFAULT, 0, 0, inst, 0)

    ShowWindow(wnd, cmd_show)
    UpdateWindow(wnd)

    msg = MSG()
    while 1:
        if not GetMessage(msg, 0, 0, 0):
            break
        TranslateMessage(msg)
        DispatchMessage(msg)
    return msg.wparam

if __name__ == '__main__':
    winmain(GetModuleHandle(None), 0, '', SW_SHOWNORMAL)
